commit 8b333df9484c1697f3a80530a47aa90b1859e970
Author: Iain Sandoe <iain@sandoe.co.uk>
Date:   Sat Jul 31 17:29:03 2021

    Darwin, X86, config: Adjust 'as' command lines [PR100340].
    
    Versions of the assembler using clang from XCode 12.5/12.5.1
    have a bug which produces different code layout between debug and
    non-debug input, leading to a compare fail for default configure
    parameters.
    
    This is a workaround fix to disable the optimisation that is
    responsible for the bug.
    
    Signed-off-by: Iain Sandoe <iain@sandoe.co.uk>
    
    PR target/100340 - Bootstrap fails with Clang 12.0.5 (XCode 12.5)
    
            PR target/100340
    
    gcc/ChangeLog:
    
            * config.in: Regenerate.
            * config/i386/darwin.h (EXTRA_ASM_OPTS): New
            (ASM_SPEC): Pass options to disable branch shortening where
            needed.
            * configure: Regenerate.
            * configure.ac: Detect versions of 'as' that support the
            optimisation which has the bug.
    
    (cherry picked from commit 743b8dd6fd757e997eb060d70fd4ae8e04fb56cd)

diff --git a/gcc/config.in b/gcc/config.in
index 18db43ce4ae..4d5da7dab3a 100644
--- a/gcc/config.in
+++ b/gcc/config.in
@@ -604,6 +604,13 @@
 #endif
 
 
+/* Define if your Mac OS X assembler supports -mllvm -x86-pad-for-align=false.
+   */
+#ifndef USED_FOR_TARGET
+#undef HAVE_AS_MLLVM_X86_PAD_FOR_ALIGN
+#endif
+
+
 /* Define if your Mac OS X assembler supports the -mmacos-version-min option.
    */
 #ifndef USED_FOR_TARGET
diff --git a/gcc/config/i386/darwin.h b/gcc/config/i386/darwin.h
index c81db9bf09f..e4a5cbea657 100644
--- a/gcc/config/i386/darwin.h
+++ b/gcc/config/i386/darwin.h
@@ -135,10 +135,18 @@ along with GCC; see the file COPYING3.  If not see
   %{mfentry*:%eDarwin does not support -mfentry or associated options}" \
   DARWIN_CC1_SPEC
 
+/* This is a workaround for a tool bug: see PR100340.  */
+
+#ifdef HAVE_AS_MLLVM_X86_PAD_FOR_ALIGN
+#define EXTRA_ASM_OPTS " -mllvm -x86-pad-for-align=false"
+#else
+#define EXTRA_ASM_OPTS ""
+#endif
+
 #undef ASM_SPEC
 #define ASM_SPEC "-arch %(darwin_arch) \
   " ASM_OPTIONS " -force_cpusubtype_ALL \
-  %{static}" ASM_MMACOSX_VERSION_MIN_SPEC
+  %{static}" ASM_MMACOSX_VERSION_MIN_SPEC EXTRA_ASM_OPTS
 
 #undef ENDFILE_SPEC
 #define ENDFILE_SPEC \
diff --git a/gcc/configure.ac b/gcc/configure.ac
index 1b31a246ae4..bd37d47f4a1 100644
--- a/gcc/configure.ac
+++ b/gcc/configure.ac
@@ -4729,6 +4729,15 @@ foo:	nop
 	fi
 	;;
     esac
+    case $target_os in
+       darwin2[[0-9]]* | darwin19*)
+        gcc_GAS_CHECK_FEATURE([llvm assembler x86-pad-for-align option],
+          gcc_cv_as_mllvm_x86_pad_for_align,,
+          [-mllvm -x86-pad-for-align=false], [.text],,
+          [AC_DEFINE(HAVE_AS_MLLVM_X86_PAD_FOR_ALIGN, 1,
+	    [Define if your Mac OS X assembler supports -mllvm -x86-pad-for-align=false.])])
+       ;;
+    esac
 
     gcc_GAS_CHECK_FEATURE([-xbrace_comment], gcc_cv_as_ix86_xbrace_comment,,
       [-xbrace_comment=no], [.text],,

